(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@tdm/core'), require('@tdm/core/tdm'), require('@tdm/data'), require('rxjs/operator/map'), require('@angular/http'), require('@angular/core'), require('@tdm/tixin')) :
	typeof define === 'function' && define.amd ? define(['exports', '@tdm/core', '@tdm/core/tdm', '@tdm/data', 'rxjs/operator/map', '@angular/http', '@angular/core', '@tdm/tixin'], factory) :
	(factory((global.tdm = global.tdm || {}, global.tdm.ngxHttp = global.tdm.ngxHttp || {}),global.tdm.core,global.tdm.core.tdm,global.tdm.data,global.Rx.Observable.prototype,global.ng.http,global.ng.core,global.tdm.tixin));
}(this, (function (exports,_tdm_core,_tdm_core_tdm,_tdm_data,rxjs_operator_map,_angular_http,_angular_core,_tdm_tixin) { 'use strict';

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var HttpResourceMetadata = (function (_super) {
    __extends(HttpResourceMetadata, _super);
    function HttpResourceMetadata() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return HttpResourceMetadata;
}(_tdm_core_tdm.ModelMetadata));
HttpResourceMetadata = __decorate([
    _tdm_core_tdm.MetaClass({
        inherit: _tdm_core_tdm.ModelMetadata
    })
], HttpResourceMetadata);

var HttpActionMethodType = {};
HttpActionMethodType.Get = 0;
HttpActionMethodType.Post = 1;
HttpActionMethodType.Put = 2;
HttpActionMethodType.Delete = 3;
HttpActionMethodType.Options = 4;
HttpActionMethodType.Head = 5;
HttpActionMethodType.Patch = 6;
HttpActionMethodType[HttpActionMethodType.Get] = "Get";
HttpActionMethodType[HttpActionMethodType.Post] = "Post";
HttpActionMethodType[HttpActionMethodType.Put] = "Put";
HttpActionMethodType[HttpActionMethodType.Delete] = "Delete";
HttpActionMethodType[HttpActionMethodType.Options] = "Options";
HttpActionMethodType[HttpActionMethodType.Head] = "Head";
HttpActionMethodType[HttpActionMethodType.Patch] = "Patch";
var METHOD_MAP = (_a = {},
    _a[HttpActionMethodType.Get] = _tdm_data.ActionMethodType.READ,
    _a[HttpActionMethodType.Post] = _tdm_data.ActionMethodType.CREATE,
    _a[HttpActionMethodType.Put] = _tdm_data.ActionMethodType.REPLACE,
    _a[HttpActionMethodType.Delete] = _tdm_data.ActionMethodType.DELETE,
    _a[HttpActionMethodType.Patch] = _tdm_data.ActionMethodType.UPDATE,
    _a);
/**
 * @param {?} method
 * @return {?}
 */
function mapMethod(method) {
    var /** @type {?} */ mapped = METHOD_MAP[method];
    return {
        source: method,
        method: typeof mapped === 'undefined' ? _tdm_data.ActionMethodType.LOCAL : mapped,
        local: typeof mapped === 'undefined'
    };
}
var _a;

var HttpDefaultConfig = (function () {
    function HttpDefaultConfig() {
        /**
         * Optional set of pre-bound parameters all actions in this resource.
         *
         * \@optional
         * \@default {}
         */
        this.urlParams = {};
        /**
         * An object containing any HTTP headers that you want to pre-populate your Headers object with.
         *
         * \@optional
         * \@default {}
         */
        this.headers = {};
        /**
         * Set the XMLHttpRequest.withCredentials property.
         *
         * \@See https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest/withCredentials
         *
         * \@optional
         * \@default false
         */
        this.withCredentials = false;
        /**
         * Trailing slashes strategy to use.
         *
         *   - **ignore**: leave calculated URL as is.
         *   - **force**:  ensure the calculated URL ens with a trailing slash
         *   - **strip**: remove all trailing slashes from the calculated URL
         *
         * \@optional
         * \@default 'ignore'
         */
        this.trailingSlashes = 'ignore';
    }
    return HttpDefaultConfig;
}());
var httpDefaultConfig = new HttpDefaultConfig();

// Taken from npm module 'path-to-regexp'
// couldn't import to to rollup issues with commonjs plugin
/**
 * The main path matching regexp utility.
 *
 */
var PATH_REGEXP = new RegExp([
    // Match escaped characters that would otherwise appear in future matches.
    // This allows the user to escape special characters that won't transform.
    '(\\\\.)',
    // Match Express-style parameters and un-named parameters with a prefix
    // and optional suffixes. Matches appear as:
    //
    // "/:test(\\d+)?" => ["/", "test", "\d+", undefined, "?", undefined]
    // "/route(\\d+)"  => [undefined, undefined, undefined, "\d+", undefined, undefined]
    // "/*"            => ["/", undefined, undefined, undefined, undefined, "*"]
    '([\\/.])?(?:(?:\\:(\\w+)(?:\\(((?:\\\\.|[^\\\\()])+)\\))?|\\(((?:\\\\.|[^\\\\()])+)\\))([+*?])?|(\\*))'
].join('|'), 'g');
/**
 * Parse a string for the raw tokens.
 *
 * @param {?} str
 * @param {?} options
 * @return {?}
 */
function parse(str, options) {
    var /** @type {?} */ tokens = [];
    var /** @type {?} */ key = 0;
    var /** @type {?} */ index = 0;
    var /** @type {?} */ path = '';
    var /** @type {?} */ defaultDelimiter = options && options.delimiter || '/';
    var /** @type {?} */ res;
    while ((res = PATH_REGEXP.exec(str)) != null) {
        var /** @type {?} */ m = res[0];
        var /** @type {?} */ escaped = res[1];
        var /** @type {?} */ offset = res.index;
        path += str.slice(index, offset);
        index = offset + m.length;
        // Ignore already escaped sequences.
        if (escaped) {
            path += escaped[1];
            continue;
        }
        var /** @type {?} */ next = str[index];
        var /** @type {?} */ prefix = res[2];
        var /** @type {?} */ name = res[3];
        var /** @type {?} */ capture = res[4];
        var /** @type {?} */ group = res[5];
        var /** @type {?} */ modifier = res[6];
        var /** @type {?} */ asterisk = res[7];
        // Push the current path onto the tokens.
        if (path) {
            tokens.push(path);
            path = '';
        }
        var /** @type {?} */ partial = prefix != null && next != null && next !== prefix;
        var /** @type {?} */ repeat = modifier === '+' || modifier === '*';
        var /** @type {?} */ optional = modifier === '?' || modifier === '*';
        var /** @type {?} */ delimiter = res[2] || defaultDelimiter;
        var /** @type {?} */ pattern = capture || group;
        tokens.push({
            name: name || key++,
            prefix: prefix || '',
            delimiter: delimiter,
            optional: optional,
            repeat: repeat,
            partial: partial,
            asterisk: !!asterisk,
            pattern: pattern ? escapeGroup(pattern) : (asterisk ? '.*' : '[^' + escapeString(delimiter) + ']+?')
        });
    }
    // Match any characters still remaining.
    if (index < str.length) {
        path += str.substr(index);
    }
    // If the path exists, push it onto the end.
    if (path) {
        tokens.push(path);
    }
    return tokens;
}
/**
 * Compile a string to a template function for the path.
 *
 * @param {?} str
 * @param {?=} options
 * @return {?}
 */
function compile(str, options) {
    return tokensToFunction(parse(str, options));
}
/**
 * Prettier encoding of URI path segments.
 *
 * @param {?} str
 * @return {?}
 */
function encodeURIComponentPretty(str) {
    return encodeURI(str).replace(/[\/?#]/g, function (c) {
        return '%' + c.charCodeAt(0).toString(16).toUpperCase();
    });
}
/**
 * Encode the asterisk parameter. Similar to `pretty`, but allows slashes.
 *
 * @param {?} str
 * @return {?}
 */
function encodeAsterisk(str) {
    return encodeURI(str).replace(/[?#]/g, function (c) {
        return '%' + c.charCodeAt(0).toString(16).toUpperCase();
    });
}
/**
 * Expose a method for transforming tokens into the path function.
 * @param {?} tokens
 * @return {?}
 */
function tokensToFunction(tokens) {
    // Compile all the tokens into regexps.
    var /** @type {?} */ matches = new Array(tokens.length);
    // Compile all the patterns before compilation.
    for (var /** @type {?} */ i = 0; i < tokens.length; i++) {
        if (typeof tokens[i] === 'object') {
            matches[i] = new RegExp('^(?:' + tokens[i].pattern + ')$');
        }
    }
    return function (obj, opts) {
        var /** @type {?} */ path = '';
        var /** @type {?} */ data = obj || {};
        var /** @type {?} */ options = opts || {};
        var /** @type {?} */ encode = options.pretty ? encodeURIComponentPretty : encodeURIComponent;
        for (var /** @type {?} */ i = 0; i < tokens.length; i++) {
            var /** @type {?} */ token = tokens[i];
            if (typeof token === 'string') {
                path += token;
                continue;
            }
            var /** @type {?} */ value = data[token.name];
            var /** @type {?} */ segment;
            if (value == null) {
                if (token.optional) {
                    // Prepend partial segment prefixes.
                    if (token.partial) {
                        path += token.prefix;
                    }
                    continue;
                }
                else {
                    throw new TypeError('Expected "' + token.name + '" to be defined');
                }
            }
            if (Array.isArray(value)) {
                if (!token.repeat) {
                    throw new TypeError('Expected "' + token.name + '" to not repeat, but received `' + JSON.stringify(value) + '`');
                }
                if (value.length === 0) {
                    if (token.optional) {
                        continue;
                    }
                    else {
                        throw new TypeError('Expected "' + token.name + '" to not be empty');
                    }
                }
                for (var /** @type {?} */ j = 0; j < value.length; j++) {
                    segment = encode(value[j]);
                    if (!matches[i].test(segment)) {
                        throw new TypeError('Expected all "' + token.name + '" to match "' + token.pattern + '", but received `' + JSON.stringify(segment) + '`');
                    }
                    path += (j === 0 ? token.prefix : token.delimiter) + segment;
                }
                continue;
            }
            segment = token.asterisk ? encodeAsterisk(value) : encode(value);
            if (!matches[i].test(segment)) {
                throw new TypeError('Expected "' + token.name + '" to match "' + token.pattern + '", but received "' + segment + '"');
            }
            path += token.prefix + segment;
        }
        return path;
    };
}
/**
 * Escape a regular expression string.
 *
 * @param {?} str
 * @return {?}
 */
function escapeString(str) {
    return str.replace(/([.+*?=^!:${}()[\]|\/\\])/g, '\\$1');
}
/**
 * Escape the capturing group by escaping special characters and meaning.
 *
 * @param {?} group
 * @return {?}
 */
function escapeGroup(group) {
    return group.replace(/([=!:$\/()])/g, '\\$1');
}
/**
 * Attach the keys as a property of the regexp.
 *
 * @param {?} re
 * @param {?} keys
 * @return {?}
 */
function attachKeys(re, keys) {
    re.keys = keys;
    return re;
}
/**
 * Get the flags for a regexp from the options.
 *
 * @param {?} options
 * @return {?}
 */
function flags(options) {
    return options.sensitive ? '' : 'i';
}
/**
 * Pull out keys from a regexp.
 *
 * @param {?} path
 * @param {?} keys
 * @return {?}
 */
function regexpToRegexp(path, keys) {
    // Use a negative lookahead to match only capturing groups.
    var /** @type {?} */ groups = path.source.match(/\((?!\?)/g);
    if (groups) {
        for (var /** @type {?} */ i = 0; i < groups.length; i++) {
            keys.push({
                name: i,
                prefix: null,
                delimiter: null,
                optional: false,
                repeat: false,
                partial: false,
                asterisk: false,
                pattern: null
            });
        }
    }
    return attachKeys(path, keys);
}
/**
 * Transform an array into a regexp.
 *
 * @param {?} path
 * @param {?} keys
 * @param {?} options
 * @return {?}
 */
function arrayToRegexp(path, keys, options) {
    var /** @type {?} */ parts = [];
    for (var /** @type {?} */ i = 0; i < path.length; i++) {
        parts.push(pathToRegexp(path[i], keys, options).source);
    }
    var /** @type {?} */ regexp = new RegExp('(?:' + parts.join('|') + ')', flags(options));
    return attachKeys(regexp, keys);
}
/**
 * Create a path regexp from string input.
 *
 * @param {?} path
 * @param {?} keys
 * @param {?} options
 * @return {?}
 */
function stringToRegexp(path, keys, options) {
    return tokensToRegExp(parse(path, options), keys, options);
}
/**
 * Expose a function for taking tokens and returning a RegExp.
 *
 * @param {?} tokens
 * @param {?} keys
 * @param {?} options
 * @return {?}
 */
function tokensToRegExp(tokens, keys, options) {
    if (!Array.isArray(keys)) {
        options = (keys || options);
        keys = [];
    }
    options = options || {};
    var /** @type {?} */ strict = options.strict;
    var /** @type {?} */ end = options.end !== false;
    var /** @type {?} */ route = '';
    // Iterate over the tokens and create our regexp string.
    for (var /** @type {?} */ i = 0; i < tokens.length; i++) {
        var /** @type {?} */ token = tokens[i];
        if (typeof token === 'string') {
            route += escapeString(token);
        }
        else {
            var /** @type {?} */ prefix = escapeString(token.prefix);
            var /** @type {?} */ capture = '(?:' + token.pattern + ')';
            keys.push(token);
            if (token.repeat) {
                capture += '(?:' + prefix + capture + ')*';
            }
            if (token.optional) {
                if (!token.partial) {
                    capture = '(?:' + prefix + '(' + capture + '))?';
                }
                else {
                    capture = prefix + '(' + capture + ')?';
                }
            }
            else {
                capture = prefix + '(' + capture + ')';
            }
            route += capture;
        }
    }
    var /** @type {?} */ delimiter = escapeString(options.delimiter || '/');
    var /** @type {?} */ endsWithDelimiter = route.slice(-delimiter.length) === delimiter;
    // In non-strict mode we allow a slash at the end of match. If the path to
    // match already ends with a slash, we remove it for consistency. The slash
    // is valid at the end of a path match, not in the middle. This is important
    // in non-ending mode, where "/test/" shouldn't match "/test//route".
    if (!strict) {
        route = (endsWithDelimiter ? route.slice(0, -delimiter.length) : route) + '(?:' + delimiter + '(?=$))?';
    }
    if (end) {
        route += '$';
    }
    else {
        // In non-ending mode, we need the capturing groups to match as much as
        // possible by using a positive lookahead to the end or next path segment.
        route += strict && endsWithDelimiter ? '' : '(?=' + delimiter + '|$)';
    }
    return attachKeys(new RegExp('^' + route, flags(options)), keys);
}
/**
 * Normalize the given path string, returning a regular expression.
 *
 * An empty array can be passed in for the keys, which will hold the
 * placeholder key descriptions. For example, using `/user/:id`, `keys` will
 * contain `[{ name: 'id', delimiter: '/', optional: false, repeat: false }]`.
 *
 * @param {?} path
 * @param {?=} keys
 * @param {?=} options
 * @return {?}
 */
function pathToRegexp(path, keys, options) {
    if (!Array.isArray(keys)) {
        options = (keys || options);
        keys = [];
    }
    options = options || {};
    if (path instanceof RegExp) {
        return regexpToRegexp(path, /** @type {!Array} */ (keys));
    }
    if (Array.isArray(path)) {
        return arrayToRegexp(/** @type {!Array} */ (path), /** @type {!Array} */ (keys), options);
    }
    return stringToRegexp(/** @type {string} */ (path), /** @type {!Array} */ (keys), options);
}

var REGEXP_CACHE = new Map();
var COMPILED_CACHE = new Map();
/**
 * @param {?} pattern
 * @return {?}
 */
function getRegexp(pattern) {
    if (!REGEXP_CACHE.has(pattern)) {
        var /** @type {?} */ keys = [];
        var /** @type {?} */ regexp = pathToRegexp(pattern, keys, { end: false });
        REGEXP_CACHE.set(pattern, { keys: keys, regexp: regexp });
    }
    return REGEXP_CACHE.get(pattern);
}
/**
 * @param {?} pattern
 * @return {?}
 */
function getCompiled(pattern) {
    if (!COMPILED_CACHE.has(pattern)) {
        COMPILED_CACHE.set(pattern, /** @type {?} */ (compile(pattern)));
    }
    return COMPILED_CACHE.get(pattern);
}
/**
 * @param {?} pattern
 * @param {?} pathname
 * @return {?}
 */

/**
 * @param {?} pattern
 * @return {?}
 */
function getParamNames(pattern) {
    return getRegexp(pattern).keys.map(function (key) { return key.name; });
}
/**
 * @param {?} paramNames
 * @param {?} paramValues
 * @return {?}
 */

/**
 * @param {?} pattern
 * @param {?} pathname
 * @return {?}
 */

/**
 * @param {?} pattern
 * @param {?=} params
 * @return {?}
 */
function formatPattern(pattern, params) {
    if (params === void 0) { params = {}; }
    return getCompiled(pattern)(params);
}

var ngHttpService;
/**
 * @return {?}
 */
function getHttp() {
    if (!ngHttpService) {
        throw new Error('Http service not present. Make sure you registered the provider and you are not invoking actions before angular bootstrapped.');
    }
    else {
        return ngHttpService;
    }
}
/**
 * @param {?} http
 * @return {?}
 */
function runAfterBootstrap(http) {
    ngHttpService = http;
    return function () { };
}

var HttpAdapter = (function () {
    function HttpAdapter() {
        this.supports = { cancel: true };
        this.executing = new Map();
        this.idCount = 1;
    }
    /**
     * @param {?} ctx
     * @param {?} options
     * @param {?} args
     * @return {?}
     */
    HttpAdapter.prototype.execute = function (ctx, options, args) {
        var _this = this;
        var /** @type {?} */ id = this.idCount++;
        try {
            var /** @type {?} */ http_1 = getHttp();
            if (!options)
                options = ({});
            var action = ctx.action;
            var /** @type {?} */ resource = ctx.targetMeta.model();
            if (!resource) {
                throw new Error('Http resource not set.');
            }
            var /** @type {?} */ url = _tdm_data.findProp('endpoint', resource, action);
            if (!url) {
                // TODO: move to @tdm error with more info.
                throw new Error('Invalid endpoint, no endpoint found.');
            }
            var /** @type {?} */ withCredentials = _tdm_data.findProp('withCredentials', httpDefaultConfig, resource, action, options);
            var /** @type {?} */ strip = _tdm_data.findProp('trailingSlashes', httpDefaultConfig, resource, action, options);
            var /** @type {?} */ urlParams = this.getParams(ctx, ctx.targetMeta, resource, options);
            var _a = this.splitParams(url, urlParams), path = _a.path, query = _a.query;
            var /** @type {?} */ requestOptions_1 = new _angular_http.RequestOptions({
                url: processUrl(this.parseUrl(url, path), strip),
                method: /** @type {?} */ (action.methodInfo.source),
                search: this.paramsToSearchParams(query),
                headers: this.getHeaders(ctx, resource, options),
                body: ctx.data,
                withCredentials: withCredentials
            });
            var /** @type {?} */ response = new Promise(function (resolve, reject) {
                var /** @type {?} */ value;
                var /** @type {?} */ subscription = rxjs_operator_map.map.call(http_1.request(requestOptions_1.url, requestOptions_1), function (response) { return ({ data: response.json(), response: response, request: requestOptions_1 }); })
                    .subscribe(function (v) { return value = v; }, function (err) {
                    _this.executing.delete(id);
                    reject(err);
                }, function () {
                    _this.executing.delete(id);
                    resolve(value);
                });
                _this.executing.set(id, subscription);
            });
            return { id: id, response: response };
        }
        catch (err) {
            return { id: id, response: Promise.reject(err) };
        }
    };
    /**
     * @param {?} id
     * @return {?}
     */
    HttpAdapter.prototype.cancel = function (id) {
        var /** @type {?} */ sub = this.executing.get(id);
        if (sub && !sub.closed) {
            sub.unsubscribe();
        }
    };
    /**
     * @param {?} ctx
     * @param {?} resource
     * @param {?} options
     * @return {?}
     */
    HttpAdapter.prototype.getHeaders = function (ctx, resource, options) {
        var /** @type {?} */ headers = new _angular_http.Headers(_tdm_data.findProp('headers', httpDefaultConfig, resource, ctx.action));
        if (options.headers) {
            Object.keys(options.headers).forEach(function (k) {
                if (_tdm_core_tdm.isUndefined(options.headers[k])) {
                    headers.delete(k);
                }
                else {
                    headers.set(k, options.headers[k]);
                }
            });
        }
        return headers;
    };
    /**
     * @param {?} ctx
     * @param {?} meta
     * @param {?} resource
     * @param {?} options
     * @return {?}
     */
    HttpAdapter.prototype.getParams = function (ctx, meta, resource, options) {
        var /** @type {?} */ params = Object.assign({}, _tdm_data.findProp('urlParams', httpDefaultConfig, resource, ctx.action));
        if (ctx.instance) {
            // we don't care about the keys (properties) UrlParam is on...
            // TODO: change how UrlParams are stored, instead of target->UrlParamMetadata->propName->Set<UrlParamMetadata>
            // store everything in one set/array to avoid this messy extraction.
            // an alternative is to cache the flattened array.
            var /** @type {?} */ boundParams = meta
                .getValues(exports.ɵc)
                .reduce(function (arr, partial) { return arr.concat(partial); }, /** @type {?} */ ([]));
            for (var /** @type {?} */ i = 0, /** @type {?} */ len = boundParams.length; i < len; i++) {
                var /** @type {?} */ bp = boundParams[i];
                if (bp.methods.length === 0 || bp.methods.some(function (mi) { return mi.method === ctx.action.method; })) {
                    params[bp.urlTemplateParamName] = ctx.instance[bp.name];
                }
            }
        }
        if (options.urlParams) {
            Object.assign(params, options.urlParams);
        }
        return params;
    };
    /**
     * @param {?} url
     * @param {?} params
     * @return {?}
     */
    HttpAdapter.prototype.parseUrl = function (url, params) {
        try {
            return formatPattern(url, params);
        }
        catch (e) {
            throw new Error("URL Parameter Error in " + _tdm_core_tdm.stringify(this.constructor) + ": " + e.message);
        }
    };
    /**
     * From a collection of parameters return those belong to the url (path) and those that are not (query).
     * @param {?} url
     * @param {?} params
     * @return {?}
     */
    HttpAdapter.prototype.splitParams = function (url, params) {
        var /** @type {?} */ pathParamNames = getParamNames(url);
        return Object.keys(params)
            .reduce(function (splitParams, key) {
            if (!_tdm_core_tdm.isUndefined(params[key])) {
                if (pathParamNames.indexOf(key) === -1) {
                    splitParams.query[key] = params[key];
                }
                else {
                    splitParams.path[key] = params[key];
                }
            }
            return splitParams;
        }, { path: {}, query: {} });
    };
    /**
     * @param {?} params
     * @return {?}
     */
    HttpAdapter.prototype.paramsToSearchParams = function (params) {
        return Object.keys(params)
            .reduce(function (search, key) {
            var /** @type {?} */ value = params[key];
            if (Array.isArray(value)) {
                value.forEach(function (q) { return search.append(key, q); });
            }
            else {
                search.append(key, value);
            }
            return search;
        }, new _angular_http.URLSearchParams());
    };
    return HttpAdapter;
}());
/**
 * @param {?} url
 * @param {?} slashes
 * @return {?}
 */
function processUrl(url, slashes) {
    switch (slashes) {
        case 'strip':
            url = url.replace(/\/+$/, '') || '/';
            break;
        case 'force':
            if (url[url.length - 1] !== '/') {
                url += '/';
            }
            break;
        default:
            break;
    }
    // E.g. `http://url.com/id./format?q=x` becomes `http://url.com/id.format?q=x`
    return url.replace(/\/\.(?=\w+($|\?))/, '.')
        .replace(/\/\\\./, '/.'); // replace escaped `/\.` with `/.`
}

var __extends$1 = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate$1 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
exports.ɵb = (function (_super) {
    __extends$1(HttpActionMetadata, _super);
    /**
     * @param {?} obj
     * @param {?} info
     */
    function HttpActionMetadata(obj, info) {
        var _this = _super.call(this, obj, info) || this;
        if (!obj.hasOwnProperty('method')) {
            throw new Error('Resource Action method is mandatory.');
        }
        _this.methodInfo = mapMethod(obj.method);
        _this.method = _this.methodInfo.method;
        return _this;
    }
    return HttpActionMetadata;
}(_tdm_data.ActionMetadata));
exports.ɵb.adapterClass = HttpAdapter;
exports.ɵb = __decorate$1([
    _tdm_core_tdm.MetaClass({
        allowOn: ['staticMember', 'member'],
        extend: _tdm_data.ActionMetadata.extend,
        register: _tdm_data.ActionMetadata.register
    }),
    __metadata("design:paramtypes", [Object, Object])
], exports.ɵb);

var __extends$2 = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate$2 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata$1 = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
 * @param {?} from
 * @param {?} to
 * @return {?}
 */
function extend(from, to) {
    if (!to) {
        to = new Map();
    }
    _tdm_core_tdm.MapExt.asKeyValArray(from)
        .forEach(function (_a) {
        var k = _a[0], v = _a[1];
        if (!to.has(k)) {
            to.set(k, v.slice());
        }
        else {
            // TODO: need to filter duplicated (based on method)
            to.set(k, to.get(k).concat(v));
        }
    });
    return to;
}
exports.ɵc = (function (_super) {
    __extends$2(UrlParamMetadata, _super);
    /**
     * @param {?} metaArgs
     * @param {?} info
     */
    function UrlParamMetadata(metaArgs, info) {
        var _this = _super.call(this, info) || this;
        _this.methods = [];
        var urlParamsMeta = {};
        if (_tdm_core_tdm.isString(metaArgs)) {
            Object.assign(urlParamsMeta, { urlTemplateParamName: metaArgs });
        }
        else {
            metaArgs && Object.assign(urlParamsMeta, metaArgs);
            if (!urlParamsMeta.urlTemplateParamName) {
                urlParamsMeta.urlTemplateParamName = info.name;
            }
        }
        Object.assign(_this, urlParamsMeta);
        if (urlParamsMeta.methods) {
            var methods = Array.isArray(urlParamsMeta.methods) ? urlParamsMeta.methods : Array.of(urlParamsMeta.methods);
            _this.methods = methods.map(mapMethod);
        }
        else {
            _this.methods = [];
        }
        return _this;
    }
    return UrlParamMetadata;
}(_tdm_core_tdm.BaseMetadata));
exports.ɵc = __decorate$2([
    _tdm_core_tdm.MetaClass({
        allowOn: ['member'],
        extend: extend,
        register: _tdm_core_tdm.registerHelpers.array,
        proxy: {
            host: _tdm_core_tdm.PropMetadata,
            containerKey: 'urlParam'
        }
    }),
    __metadata$1("design:paramtypes", [Object, Object])
], exports.ɵc);

/**
 * \@propertyDecorator both
 * @param def
 */
var HttpAction = _tdm_core_tdm.MetaClass.decorator(exports.ɵb);
/**
 * \@propertyDecorator instance
 * @param metaArgs
 */
var UrlParam = _tdm_core_tdm.MetaClass.decorator(exports.ɵc, true);
// FOR AOT
// export const HttpResource = df.resource<HttpResourceMetadataArgs>(HttpAdapter);
var httpResource = _tdm_core_tdm.MetaClass.get(HttpResourceMetadata).createResourceDecorator(HttpAdapter);
/**
 * \@classDecorator
 * @param {?} def
 * @return {?}
 */
function HttpResource(def) {
    if (!def.endpoint) {
        throw new Error('Resource endpoint is mandatory.');
    }
    return (httpResource(def));
}

var __decorate$3 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata$2 = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
// export type X = {
//   [P in keyof TargetDAO<any, any>]?: PropertyDecorator
// }
var HttpDAOActions = {
    query: HttpAction({
        method: HttpActionMethodType.Get,
        isCollection: true,
        collInstance: true,
        validation: /** @type {?} */ ('incoming'),
        alias: 'findAll'
    }),
    findById: HttpAction({
        method: HttpActionMethodType.Get,
        validation: /** @type {?} */ ('incoming'),
        pre: function (ctx, id, options) {
            ctx.setIdentity(id);
            return options;
        }
    }),
    find: HttpAction({
        method: HttpActionMethodType.Get,
        validation: /** @type {?} */ ('incoming'),
        alias: 'findOne'
    }),
    create: HttpAction({
        method: HttpActionMethodType.Post,
        validation: /** @type {?} */ ('both'),
        pre: function (ctx, data, options) {
            if (ctx.instanceOf(data)) {
                ctx.setInstance(data);
            }
            else {
                ctx.deserialize(data);
            }
            ctx.data = ctx.serialize();
            return options;
        }
    }),
    update: HttpAction({
        method: HttpActionMethodType.Put,
        validation: /** @type {?} */ ('both'),
        pre: function (ctx, data, options) {
            if (ctx.instanceOf(data)) {
                ctx.setInstance(data);
            }
            else {
                ctx.deserialize(data);
            }
            ctx.data = ctx.serialize();
            return options;
        }
    }),
    remove: HttpAction({
        method: HttpActionMethodType.Delete,
        validation: /** @type {?} */ ('skip'),
        pre: function (ctx, id, options) {
            if (_tdm_core_tdm.isPrimitive(id)) {
                ctx.setIdentity(id);
            }
            else if (ctx.instanceOf(id)) {
                ctx.setInstance(id);
            }
            else {
                ctx.deserialize(id);
            }
            return options;
        }
    })
};
var HttpDao = (function () {
    function HttpDao() {
    }
    return HttpDao;
}());
__decorate$3([
    HttpDAOActions.query,
    __metadata$2("design:type", Function)
], HttpDao.prototype, "query", void 0);
__decorate$3([
    HttpDAOActions.findById,
    __metadata$2("design:type", Function)
], HttpDao.prototype, "findById", void 0);
__decorate$3([
    HttpDAOActions.find,
    __metadata$2("design:type", Function)
], HttpDao.prototype, "find", void 0);
__decorate$3([
    HttpDAOActions.create,
    __metadata$2("design:type", Function)
], HttpDao.prototype, "create", void 0);
__decorate$3([
    HttpDAOActions.update,
    __metadata$2("design:type", Function)
], HttpDao.prototype, "update", void 0);
__decorate$3([
    HttpDAOActions.remove,
    __metadata$2("design:type", Function)
], HttpDao.prototype, "remove", void 0);

_tdm_core_tdm.targetStore.registerAdapter(HttpAdapter, {
    actionMetaClass: exports.ɵb,
    DAOClass: HttpDao,
    resourceMetaClass: HttpResourceMetadata
});
/**
 * An HttpDAO factory based for a target.
 */
var NgDAO = (function () {
    function NgDAO() {
    }
    /**
     * @template T, Z
     * @param {?} target
     * @return {?}
     */
    NgDAO.prototype.get = function (target) {
        return _tdm_data.DAO.of(HttpAdapter, target);
    };
    return NgDAO;
}());
_tdm_data.DAO.angularHttp = NgDAO.prototype.get;

var HttpResourceModuleForRoot = (function () {
    /**
     * @param {?} http
     */
    function HttpResourceModuleForRoot(http) {
        runAfterBootstrap(http);
    }
    return HttpResourceModuleForRoot;
}());
HttpResourceModuleForRoot.decorators = [
    { type: _angular_core.NgModule, args: [{
                imports: [_angular_http.HttpModule]
            },] },
];
/**
 * @nocollapse
 */
HttpResourceModuleForRoot.ctorParameters = function () { return [
    { type: _angular_http.Http, },
]; };
var HttpResourceModule = (function () {
    function HttpResourceModule() {
    }
    /**
     * @return {?}
     */
    HttpResourceModule.forRoot = function () {
        return {
            ngModule: HttpResourceModuleForRoot,
            providers: [NgDAO]
        };
    };
    return HttpResourceModule;
}());
HttpResourceModule.decorators = [
    { type: _angular_core.NgModule },
];
/**
 * @nocollapse
 */
HttpResourceModule.ctorParameters = function () { return []; };

var __decorate$4 = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata$3 = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var HttpActiveRecord = (function () {
    function HttpActiveRecord() {
    }
    return HttpActiveRecord;
}());
__decorate$4([
    HttpAction({
        method: HttpActionMethodType.Post,
        validation: /** @type {?} */ ('both'),
        pre: function (ctx, options) {
            ctx.data = ctx.serialize();
            return options;
        }
    }),
    __metadata$3("design:type", Function)
], HttpActiveRecord.prototype, "$create", void 0);
__decorate$4([
    HttpAction({
        method: HttpActionMethodType.Get,
        validation: /** @type {?} */ ('incoming')
    }),
    __metadata$3("design:type", Function)
], HttpActiveRecord.prototype, "$refresh", void 0);
__decorate$4([
    HttpAction({
        method: HttpActionMethodType.Put,
        validation: /** @type {?} */ ('both'),
        pre: function (ctx, options) {
            ctx.data = ctx.serialize();
            return options;
        }
    }),
    __metadata$3("design:type", Function)
], HttpActiveRecord.prototype, "$update", void 0);
__decorate$4([
    HttpAction({
        method: HttpActionMethodType.Delete,
        validation: /** @type {?} */ ('skip')
    }),
    __metadata$3("design:type", Function)
], HttpActiveRecord.prototype, "$remove", void 0);
__decorate$4([
    HttpDAOActions.query,
    __metadata$3("design:type", Function)
], HttpActiveRecord, "query", void 0);
__decorate$4([
    HttpDAOActions.findById,
    __metadata$3("design:type", Function)
], HttpActiveRecord, "findById", void 0);
__decorate$4([
    HttpDAOActions.find,
    __metadata$3("design:type", Function)
], HttpActiveRecord, "find", void 0);
__decorate$4([
    HttpDAOActions.create,
    __metadata$3("design:type", Function)
], HttpActiveRecord, "create", void 0);
__decorate$4([
    HttpDAOActions.update,
    __metadata$3("design:type", Function)
], HttpActiveRecord, "update", void 0);
__decorate$4([
    HttpDAOActions.remove,
    __metadata$3("design:type", Function)
], HttpActiveRecord, "remove", void 0);
var ActiveRecordCollection = _tdm_data.TDMCollection;

/* tslint:disable:max-line-length */
/**
 * @template Model, TypeofModel, TMIXIN, CMIXIN
 * @param {?=} model
 * @param {...?} mixins
 * @return {?}
 */
function ARMixin(model) {
    var mixins = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        mixins[_i - 1] = arguments[_i];
    }
    _tdm_data.plugins.assertPlugin('ActiveRecord'); // make sure plugin attached
    if (!model) {
        model = ((function () {
            function class_1() {
            }
            return class_1;
        }()));
    }
    // a model might not be a target at this point (i.e. it has no metadata)
    _tdm_core_tdm.targetStore.registerTarget(model);
    /**
     * Marking the mixin HttpActiveRecord for model.
     * Since model is an extending class, it's type will be traversed and looked up for mixins
     * so the deriving class (base) will get all the actions from the HttpActiveRecord
     *
     */
    _tdm_data.store.markMixins.apply(_tdm_data.store, [model, HttpAdapter, HttpActiveRecord].concat(mixins));
    // we can't send ...mixin to Tixin since the type limits the ..mixins amount
    var /** @type {?} */ result = ((_tdm_tixin.Tixin)).apply(void 0, [model, HttpActiveRecord].concat(mixins));
    var /** @type {?} */ tMeta = _tdm_core_tdm.targetStore.getTargetMeta(result);
    if (tMeta.hasModel) {
        tMeta.model().build(true);
    }
    return (result);
}

exports.HttpActionMethodType = HttpActionMethodType;
exports.HttpAction = HttpAction;
exports.UrlParam = UrlParam;
exports.HttpResource = HttpResource;
exports.NgDAO = NgDAO;
exports.httpDefaultConfig = httpDefaultConfig;
exports.HttpDefaultConfig = HttpDefaultConfig;
exports.HttpResourceModule = HttpResourceModule;
exports.ARMixin = ARMixin;
exports.ActiveRecordCollection = ActiveRecordCollection;
exports.HttpActiveRecord = HttpActiveRecord;
exports.ɵa = HttpResourceModuleForRoot;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-http.rollup.umd.js.map
