import { Tixin } from '@tdm/tixin';
import { TDMCollection as ARecordColl, TDMModel, IdentityValueType } from '@tdm/data';
import { HttpActionOptions } from '../core/interfaces';
export declare class HttpActiveRecord {
    $create: (options?: HttpActionOptions) => this;
    $refresh: (options?: HttpActionOptions) => this;
    $update: (options?: HttpActionOptions) => this;
    $remove: (options?: HttpActionOptions) => this;
    static query: (options?: HttpActionOptions) => any;
    static findAll: (options?: HttpActionOptions) => any;
    static findById: (id: IdentityValueType, options?: HttpActionOptions) => any;
    static find: (options: HttpActionOptions) => any;
    static findOne: (options: HttpActionOptions) => any;
    static create: (data: any | Partial<any>, options?: HttpActionOptions) => any;
    static update: (data: any | Partial<any>, options?: HttpActionOptions) => any;
    static remove: ((id: IdentityValueType | any, options?: HttpActionOptions) => any);
}
export declare const ActiveRecordCollection: typeof ARecordColl;
export declare type ActiveRecordCollection<T> = ARecordColl<Tixin<T, TDMModel<T> & HttpActiveRecord>> & {
    query: ActiveRecordCollection<T>;
};
export interface HttpActiveRecordStatic<T> {
    findById(id: IdentityValueType, options?: HttpActionOptions): Tixin<T, TDMModel<T> & HttpActiveRecord>;
    find(options: HttpActionOptions): Tixin<T, TDMModel<T> & HttpActiveRecord>;
    findOne(options: HttpActionOptions): Tixin<T, TDMModel<T> & HttpActiveRecord>;
    query(options?: HttpActionOptions): ActiveRecordCollection<T>;
    findAll(options?: HttpActionOptions): ActiveRecordCollection<T>;
    create(data: T, options?: HttpActionOptions): Tixin<T, TDMModel<T> & HttpActiveRecord>;
    update(data: Partial<T>, options?: HttpActionOptions): Tixin<T, TDMModel<T> & HttpActiveRecord>;
    remove(id: IdentityValueType | T, options?: HttpActionOptions): Tixin<T, TDMModel<T> & HttpActiveRecord>;
}
