import { Headers } from '@angular/http';
import { TargetMetadata } from '@tdm/core/tdm';
import { Adapter, ExecuteContext, AdapterResponse } from '@tdm/data';
import { HttpResourceMetadata, HttpActionMetadata } from '../metadata';
import { HttpActionOptions } from './interfaces';
import { Params } from '../utils/match-pattern';
export declare class HttpAdapter implements Adapter<HttpActionMetadata, HttpActionOptions> {
    readonly supports: {
        cancel: boolean;
    };
    private executing;
    private idCount;
    execute(ctx: ExecuteContext<HttpActionMetadata>, options: HttpActionOptions, args: any[]): AdapterResponse;
    cancel(id: number): void;
    protected getHeaders(ctx: ExecuteContext<HttpActionMetadata>, resource: HttpResourceMetadata, options: HttpActionOptions): Headers;
    protected getParams(ctx: ExecuteContext<HttpActionMetadata>, meta: TargetMetadata, resource: HttpResourceMetadata, options: HttpActionOptions): Params;
    protected parseUrl(url: string, params: Params): string;
    /**
     * From a collection of parameters return those belong to the url (path) and those that are not (query).
     * @param url
     * @param params
     * @returns {{path: {}, query: {}}}
     */
    protected splitParams(url: string, params: Params): {
        path: Params;
        query: Params;
    };
    private paramsToSearchParams(params);
}
