import { TDMCollection as ARecordColl, TargetDAO, IdentityValueType } from '@tdm/data';
import { HttpActionOptions } from './interfaces';
export declare const HttpDAOActions: {
    query: (target: Object, key: PropertyKey, desc?: PropertyDescriptor) => any;
    findById: (target: Object, key: PropertyKey, desc?: PropertyDescriptor) => any;
    find: (target: Object, key: PropertyKey, desc?: PropertyDescriptor) => any;
    create: (target: Object, key: PropertyKey, desc?: PropertyDescriptor) => any;
    update: (target: Object, key: PropertyKey, desc?: PropertyDescriptor) => any;
    remove: (target: Object, key: PropertyKey, desc?: PropertyDescriptor) => any;
};
export declare class HttpDao<T> implements TargetDAO<T, HttpActionOptions> {
    query: (options?: HttpActionOptions) => Promise<ARecordColl<T>>;
    findAll: (options?: HttpActionOptions) => Promise<ARecordColl<T>>;
    findById: (id: IdentityValueType, options?: HttpActionOptions) => Promise<T>;
    find: (options: HttpActionOptions) => Promise<T>;
    findOne: (options: HttpActionOptions) => Promise<T>;
    create: (data: T | Partial<T>, options?: HttpActionOptions) => Promise<T | void>;
    update: (data: T | Partial<T>, options?: HttpActionOptions) => Promise<T | void>;
    remove: ((id: IdentityValueType | T, options?: HttpActionOptions) => Promise<void>);
}
