var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { isPrimitive } from '@tdm/core/tdm';
import { HttpActionMethodType } from '../metadata/index';
import { HttpAction } from '../decorators';
// export type X = {
//   [P in keyof TargetDAO<any, any>]?: PropertyDecorator
// }
export var /** @type {?} */ HttpDAOActions = {
    query: HttpAction({
        method: HttpActionMethodType.Get,
        isCollection: true,
        collInstance: true,
        validation: /** @type {?} */ ('incoming'),
        alias: 'findAll'
    }),
    findById: HttpAction({
        method: HttpActionMethodType.Get,
        validation: /** @type {?} */ ('incoming'),
        pre: function (ctx, id, options) {
            ctx.setIdentity(id);
            return options;
        }
    }),
    find: HttpAction({
        method: HttpActionMethodType.Get,
        validation: /** @type {?} */ ('incoming'),
        alias: 'findOne'
    }),
    create: HttpAction({
        method: HttpActionMethodType.Post,
        validation: /** @type {?} */ ('both'),
        pre: function (ctx, data, options) {
            if (ctx.instanceOf(data)) {
                ctx.setInstance(data);
            }
            else {
                ctx.deserialize(data);
            }
            ctx.data = ctx.serialize();
            return options;
        }
    }),
    update: HttpAction({
        method: HttpActionMethodType.Put,
        validation: /** @type {?} */ ('both'),
        pre: function (ctx, data, options) {
            if (ctx.instanceOf(data)) {
                ctx.setInstance(data);
            }
            else {
                ctx.deserialize(data);
            }
            ctx.data = ctx.serialize();
            return options;
        }
    }),
    remove: HttpAction({
        method: HttpActionMethodType.Delete,
        validation: /** @type {?} */ ('skip'),
        pre: function (ctx, id, options) {
            if (isPrimitive(id)) {
                ctx.setIdentity(id);
            }
            else if (ctx.instanceOf(id)) {
                ctx.setInstance(id);
            }
            else {
                ctx.deserialize(id);
            }
            return options;
        }
    })
};
var HttpDao = (function () {
    function HttpDao() {
    }
    return HttpDao;
}());
export { HttpDao };
__decorate([
    HttpDAOActions.query,
    __metadata("design:type", Function)
], HttpDao.prototype, "query", void 0);
__decorate([
    HttpDAOActions.findById,
    __metadata("design:type", Function)
], HttpDao.prototype, "findById", void 0);
__decorate([
    HttpDAOActions.find,
    __metadata("design:type", Function)
], HttpDao.prototype, "find", void 0);
__decorate([
    HttpDAOActions.create,
    __metadata("design:type", Function)
], HttpDao.prototype, "create", void 0);
__decorate([
    HttpDAOActions.update,
    __metadata("design:type", Function)
], HttpDao.prototype, "update", void 0);
__decorate([
    HttpDAOActions.remove,
    __metadata("design:type", Function)
], HttpDao.prototype, "remove", void 0);
function HttpDao_tsickle_Closure_declarations() {
    /** @type {?} */
    HttpDao.prototype.query;
    /** @type {?} */
    HttpDao.prototype.findAll;
    /** @type {?} */
    HttpDao.prototype.findById;
    /** @type {?} */
    HttpDao.prototype.find;
    /** @type {?} */
    HttpDao.prototype.findOne;
    /** @type {?} */
    HttpDao.prototype.create;
    /** @type {?} */
    HttpDao.prototype.update;
    /** @type {?} */
    HttpDao.prototype.remove;
}
//# sourceMappingURL=http-dao.js.map