import { MetaClass } from '@tdm/core/tdm';
import { HttpAdapter } from './core/index';
import { HttpResourceMetadata, HttpActionMetadata, UrlParamMetadata } from './metadata/index';
/**
 * \@propertyDecorator both
 * @param def
 */
export var HttpAction = MetaClass.decorator(HttpActionMetadata);
/**
 * \@propertyDecorator instance
 * @param metaArgs
 */
export var UrlParam = MetaClass.decorator(UrlParamMetadata, true);
// FOR AOT
// export const HttpResource = df.resource<HttpResourceMetadataArgs>(HttpAdapter);
var /** @type {?} */ httpResource = MetaClass.get(HttpResourceMetadata).createResourceDecorator(HttpAdapter);
/**
 * \@classDecorator
 * @param {?} def
 * @return {?}
 */
export function HttpResource(def) {
    if (!def.endpoint) {
        throw new Error('Resource endpoint is mandatory.');
    }
    return (httpResource(def));
}
//# sourceMappingURL=decorators.js.map