var HttpDefaultConfig = (function () {
    function HttpDefaultConfig() {
        /**
         * Optional set of pre-bound parameters all actions in this resource.
         *
         * \@optional
         * \@default {}
         */
        this.urlParams = {};
        /**
         * An object containing any HTTP headers that you want to pre-populate your Headers object with.
         *
         * \@optional
         * \@default {}
         */
        this.headers = {};
        /**
         * Set the XMLHttpRequest.withCredentials property.
         *
         * \@See https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest/withCredentials
         *
         * \@optional
         * \@default false
         */
        this.withCredentials = false;
        /**
         * Trailing slashes strategy to use.
         *
         *   - **ignore**: leave calculated URL as is.
         *   - **force**:  ensure the calculated URL ens with a trailing slash
         *   - **strip**: remove all trailing slashes from the calculated URL
         *
         * \@optional
         * \@default 'ignore'
         */
        this.trailingSlashes = 'ignore';
    }
    return HttpDefaultConfig;
}());
export { HttpDefaultConfig };
function HttpDefaultConfig_tsickle_Closure_declarations() {
    /**
     * Optional set of pre-bound parameters all actions in this resource.
     *
     * \@optional
     * \@default {}
     * @type {?}
     */
    HttpDefaultConfig.prototype.urlParams;
    /**
     * An object containing any HTTP headers that you want to pre-populate your Headers object with.
     *
     * \@optional
     * \@default {}
     * @type {?}
     */
    HttpDefaultConfig.prototype.headers;
    /**
     * Set the XMLHttpRequest.withCredentials property.
     *
     * \@See https://developer.mozilla.org/en-US/docs/Web/API/XMLHttpRequest/withCredentials
     *
     * \@optional
     * \@default false
     * @type {?}
     */
    HttpDefaultConfig.prototype.withCredentials;
    /**
     * Trailing slashes strategy to use.
     *
     *   - **ignore**: leave calculated URL as is.
     *   - **force**:  ensure the calculated URL ens with a trailing slash
     *   - **strip**: remove all trailing slashes from the calculated URL
     *
     * \@optional
     * \@default 'ignore'
     * @type {?}
     */
    HttpDefaultConfig.prototype.trailingSlashes;
}
export var /** @type {?} */ httpDefaultConfig = new HttpDefaultConfig();
//# sourceMappingURL=http-default-config.js.map