import { DecoratorInfo } from '@tdm/core/tdm';
import { ActionMetadata, ActionMetadataArgs } from '@tdm/data';
import { HttpAdapter } from '../core';
import { Params } from '../utils/match-pattern';
import { BaseHttpConfig, TrailingSlashesStrategy } from '../core/interfaces';
import { MappedMethod, HttpActionMethodType } from './method-mapper';
export interface HttpActionMetadataArgs extends ActionMetadataArgs<HttpActionMethodType>, BaseHttpConfig {
    /**
     * action specific url override. The url templating is supported just like for the resource-level urls.
     * @optional
     * @default undefined
     */
    endpoint?: string;
}
export declare class HttpActionMetadata extends ActionMetadata {
    methodInfo: MappedMethod;
    endpoint?: string;
    urlParams?: Params;
    headers?: {
        [key: string]: any;
    };
    withCredentials?: boolean;
    trailingSlashes?: TrailingSlashesStrategy;
    constructor(obj: HttpActionMetadataArgs, info: DecoratorInfo);
    static adapterClass: typeof HttpAdapter;
}
