import { ActionMethodType } from '@tdm/data';
export var HttpActionMethodType = {};
HttpActionMethodType.Get = 0;
HttpActionMethodType.Post = 1;
HttpActionMethodType.Put = 2;
HttpActionMethodType.Delete = 3;
HttpActionMethodType.Options = 4;
HttpActionMethodType.Head = 5;
HttpActionMethodType.Patch = 6;
HttpActionMethodType[HttpActionMethodType.Get] = "Get";
HttpActionMethodType[HttpActionMethodType.Post] = "Post";
HttpActionMethodType[HttpActionMethodType.Put] = "Put";
HttpActionMethodType[HttpActionMethodType.Delete] = "Delete";
HttpActionMethodType[HttpActionMethodType.Options] = "Options";
HttpActionMethodType[HttpActionMethodType.Head] = "Head";
HttpActionMethodType[HttpActionMethodType.Patch] = "Patch";
var /** @type {?} */ METHOD_MAP = (_a = {},
    _a[HttpActionMethodType.Get] = ActionMethodType.READ,
    _a[HttpActionMethodType.Post] = ActionMethodType.CREATE,
    _a[HttpActionMethodType.Put] = ActionMethodType.REPLACE,
    _a[HttpActionMethodType.Delete] = ActionMethodType.DELETE,
    _a[HttpActionMethodType.Patch] = ActionMethodType.UPDATE,
    _a);
/**
 * @param {?} method
 * @return {?}
 */
export function mapMethod(method) {
    var /** @type {?} */ mapped = METHOD_MAP[method];
    return {
        source: method,
        method: typeof mapped === 'undefined' ? ActionMethodType.LOCAL : mapped,
        local: typeof mapped === 'undefined'
    };
}
var _a;
//# sourceMappingURL=method-mapper.js.map