import { BaseMetadata, DecoratorInfo } from '@tdm/core/tdm';
import { MappedMethod, HttpActionMethodType } from './method-mapper';
export interface UrlParamMetadataArgs {
    /**
     * Optional parameter that specifies the name of the URL template parameter.
     * When not provided, the name of the decorated property is used.
     *
     * @optional
     * @default property name
     */
    urlTemplateParamName?: string;
    /**
     * A list of methods the UrlParam applies on.
     * When not provided, applies on all methods.
     *
     * @optional
     * @default undefined
     */
    methods?: HttpActionMethodType | HttpActionMethodType[];
}
export declare class UrlParamMetadata extends BaseMetadata {
    urlTemplateParamName: string;
    methods: MappedMethod[];
    constructor(metaArgs: UrlParamMetadataArgs | string | undefined, info: DecoratorInfo);
}
declare module '@tdm/core/tdm/src/metadata/prop' {
    interface PropMetadataArgs {
        urlParam?: UrlParamMetadataArgs | undefined;
    }
}
