var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { isString, registerHelpers, MapExt, BaseMetadata, PropMetadata, MetaClass } from '@tdm/core/tdm';
import { mapMethod } from './method-mapper';
/**
 * @param {?} from
 * @param {?} to
 * @return {?}
 */
function extend(from, to) {
    if (!to) {
        to = new Map();
    }
    MapExt.asKeyValArray(from)
        .forEach(function (_a) {
        var k = _a[0], v = _a[1];
        if (!to.has(k)) {
            to.set(k, v.slice());
        }
        else {
            // TODO: need to filter duplicated (based on method)
            to.set(k, to.get(k).concat(v));
        }
    });
    return to;
}
var UrlParamMetadata = (function (_super) {
    __extends(UrlParamMetadata, _super);
    /**
     * @param {?} metaArgs
     * @param {?} info
     */
    function UrlParamMetadata(metaArgs, info) {
        var _this = _super.call(this, info) || this;
        _this.methods = [];
        var urlParamsMeta = {};
        if (isString(metaArgs)) {
            Object.assign(urlParamsMeta, { urlTemplateParamName: metaArgs });
        }
        else {
            metaArgs && Object.assign(urlParamsMeta, metaArgs);
            if (!urlParamsMeta.urlTemplateParamName) {
                urlParamsMeta.urlTemplateParamName = info.name;
            }
        }
        Object.assign(_this, urlParamsMeta);
        if (urlParamsMeta.methods) {
            var methods = Array.isArray(urlParamsMeta.methods) ? urlParamsMeta.methods : Array.of(urlParamsMeta.methods);
            _this.methods = methods.map(mapMethod);
        }
        else {
            _this.methods = [];
        }
        return _this;
    }
    return UrlParamMetadata;
}(BaseMetadata));
UrlParamMetadata = __decorate([
    MetaClass({
        allowOn: ['member'],
        extend: extend,
        register: registerHelpers.array,
        proxy: {
            host: PropMetadata,
            containerKey: 'urlParam'
        }
    }),
    __metadata("design:paramtypes", [Object, Object])
], UrlParamMetadata);
export { UrlParamMetadata };
function UrlParamMetadata_tsickle_Closure_declarations() {
    /** @type {?} */
    UrlParamMetadata.prototype.urlTemplateParamName;
    /** @type {?} */
    UrlParamMetadata.prototype.methods;
}
//# sourceMappingURL=url-params.js.map