import { Constructor } from '@tdm/core/tdm';
import { HttpDao } from './core/http-dao';
/**
 * An HttpDAO factory based for a target.
 */
export declare class NgDAO {
    get<T, Z>(target: Z & Constructor<T>): HttpDao<T>;
}
declare module '@tdm/data/src/dao' {
    module DAO {
        /**
         * Data Access Object for Angular HTTP adapter.
         * @extension '@tdm/ngx-http'
         */
        function angularHttp<T>(target: Constructor<T>): HttpDao<T>;
    }
}
