import { Key } from 'path-to-regexp';
export interface Params {
    [param: string]: string | string[];
}
export declare type CompiledPatternFactory = (params: Params) => string;
export interface ParsedPattern {
    regexp: RegExp;
    keys: Key[];
}
export interface ParsedPath {
    remainingPathname: string | null;
    paramNames: Array<string | number>;
    paramValues: Array<string>;
}
export declare function getRegexp(pattern: string): ParsedPattern;
export declare function getCompiled(pattern: string): CompiledPatternFactory;
export declare function matchPattern(pattern: string, pathname: string): ParsedPath;
export declare function getParamNames(pattern: string): Array<string | number>;
export declare function makeParams(paramNames: (string | number)[], paramValues: any[]): Params;
export declare function getParams(pattern: string, pathname: string): Params;
export declare function formatPattern(pattern: string, params?: Params): string;
